﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	
	Private nativeMe As JavaObject
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
	nativeMe = Me
	
End Sub

'draw the pie chart
public Sub drawPieChart As JavaObject
	
	Return nativeMe.RunMethod("drawChart", Null)
	
End Sub

'set the width of the chart
public Sub setGraphWidth(wdth As Int)
	
	nativeMe.RunMethod("setGraphWidth", Array(wdth))
	
End Sub

'set the height of the chart
Public Sub setGraphHeight(hght As Int)
	
	nativeMe.RunMethod("setGraphHeight", Array(hght))
	
End Sub

'set the title of the chart
public Sub setGraphTitle(title As String)
	
	nativeMe.RunMethod("setGraphTitle", Array(title))
	
End Sub

'set the graph to be circular or to follow the width/height of the pane
public Sub setGraphCircular(circ As Boolean)
	
	nativeMe.RunMethod("setCircular", Array(circ))
End Sub


#If Java

import org.knowm.xchart.PieChart;
import org.knowm.xchart.PieChartBuilder;
//import org.knowm.xchart.SwingWrapper;
import org.knowm.xchart.style.Styler;
import javafx.scene.Node;
import javax.swing.JPanel;

import org.knowm.xchart.QuickChart;
import org.knowm.xchart.XChartPanel;
import org.knowm.xchart.XYChart;
import org.knowm.xchart.XYChartBuilder;
import org.knowm.xchart.XYSeries.XYSeriesRenderStyle;
import org.knowm.xchart.internal.chartpart.Chart;
import org.knowm.xchart.style.Styler.LegendPosition;
import javafx.embed.swing.SwingNode;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.Pane;


	private int wdth = 400;
	public void setGraphWidth(int wdth) {
		this.wdth = wdth;
	}
	
	private int hght = 400;
	public void setGraphHeight(int hght) {
		this.hght = hght;
	}	
	
	private String graphTitle = "";
	public void setGraphTitle(String graphTitle) {
		this.graphTitle = graphTitle;
	}	
	
	private boolean circ = false;
	public void setCircular(boolean circ) {
		this.circ = circ;
	}	
	
	
	public Pane drawChart() {
	    PieChart chart =
	        new PieChartBuilder().width(wdth).height(hght).title(graphTitle).build();

	    // Customize Chart
	    chart.getStyler().setCircular(circ);
	    chart.getStyler().setLegendPosition(Styler.LegendPosition.OutsideS);
	    chart.getStyler().setLegendLayout(Styler.LegendLayout.Horizontal);

	    // Series
	    chart.addSeries("Pennies", 100);
	    chart.addSeries("Nickels", 50);
	    chart.addSeries("Dimes", 70);
	    chart.addSeries("Quarters", 170);
		
		
		SwingNode swingNode = new SwingNode();	
	    JPanel chartPanel = new XChartPanel(chart);
	    swingNode.setContent(chartPanel);	
		
		Pane pane = new Pane(swingNode);	

		return pane;
	
	} 

#End If
